//      story
function getStoriesFromSelection (mySelection) {
	var myStories = new Array();
	var myCount = 0;
	for (myCounter = 0; myCounter < mySelection.length; myCounter++) {
		if ((mySelection[myCounter].constructor.name == "TextFrame") || (mySelection[myCounter].constructor.name == "Text") || (mySelection[myCounter].constructor.name == "InsertionPoint")) {
			myFlag = false;
			for (myCounterOne = 0; myCounterOne < myStories.length; myCounterOne++) {
				if (mySelection[myCounter].parentStory === myStories[myCounterOne]) {
					myFlag = true;
					break;
				}
			}
			if (!myFlag) {
				myStories[myCount] = mySelection[myCounter].parentStory;
				myCount++;
			}
		}
	}
	return myStories;
}
//    
function getStyledParagraphLength(myStory, myStyle) {
	var myArray = 0;
	var mySize = 0;
	with (app) {
		findPreferences = null;
		changePreferences = null;
		findPreferences.appliedParagraphStyle = activeDocument.paragraphStyles[myStyle];
		myArray = myStory.search("");
		findPreferences = null;
		changePreferences = null;		
	}
	for (myCounter = 0; myCounter < myArray.length; myCounter++) {
		mySize+= myArray[myCounter].pointSize;
	}
	mySize=mySize/myArray.length;
	return new Array (myArray.length, mySize);
}
//     -
function resizeText(myObject, myStyle, mySize, myLeading) {
	with (app) {
		findPreferences = null;
		changePreferences = null;
		findPreferences.appliedParagraphStyle = activeDocument.paragraphStyles[myStyle];
		if (mySize > 0) {
			changePreferences.pointSize = mySize;
		} else {
			changePreferences.pointSize = activeDocument.paragraphStyles[myStyle].pointSize;
		}
		
		if (myLeading) {
			changePreferences.leading = -1;
		}
		if (myObject.constructor.name == "Array") {
			for (myCounter = 0; myCounter < myObject.length; myCounter++) {
				myObject[myCounter].search("", undefined, undefined, "");
			}
		} else {
			myObject.search("", undefined, undefined, "");
		}	
		findPreferences = null;
		changePreferences = null;
	}
}
//  
function fitText(myStory, myStyle, myLeading) {
		var myParaCountSize = getStyledParagraphLength(myStory, myStyle);
		if (myParaCountSize[0] < 1) {
			return null;
			exit();
		}
		var myTextFrame = myStory.textFrames[0];
		var mySize = myParaCountSize[1];
		myStep = mySize;
		var myRepeat = iniInteration;
		do {
			var myStatus = myTextFrame.overflows;
			myStep = myStep/iniJump;
			while (myTextFrame.overflows == myStatus) {
				if (myStatus) {
					mySize = mySize - myStep;
					resizeText (myStory, myStyle, mySize, myLeading);
				} else {
					mySize = mySize + myStep;
					resizeText (myStory, myStyle, mySize, myLeading);					
				}
				myRepeat--;
				if (myRepeat < 0) {
					return null;
					exit();				
				}
			}

		} while (myStep > iniMinimum);
}
// 
with (app) {
// ini-   
	var myIniFile = new File (activeScript.path + "/TextResizer.ini");
	if (!myIniFile.exists) {
		alert("Can\'t find ini file!");
		exit ();
	} else {
		eval ("//@include \'TextResizer.ini\';");
	}
	var myLangFile = new File (activeScript.path + "/" + iniLangFile);
	if (!myLangFile.exists) {
		alert("Can\'t find lang file!");
		exit ();
	} else {
		eval ("//@include \'" + iniLangFile + "\';");
	}
//  
	if (documents.length < 1) {
		alert(langNoDocOpen);
		exit();
	}
//  
	var myParaStyleNames = new Array();
	for (myCounter = 0; myCounter < activeDocument.paragraphStyles.length; myCounter++) {
		myParaStyleNames[myCounter] = activeDocument.paragraphStyles[myCounter].name;
	}
// 
	var myDialog = dialogs.add({name:iniScriptName + " " + iniScriptVersion});
	with (myDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add().dialogColumns.add()) {
				dialogRows.add().staticTexts.add({staticLabel:langResizeTextIn});
				var myObjects = dialogRows.add().radiobuttonGroups.add();
				with (myObjects) {
					radiobuttonControls.add({staticLabel:langActiveObjects, checkedState:(selection.length > 0 ? true : false)});
					radiobuttonControls.add({staticLabel:langActiveDocument, checkedState:(selection.length < 1 ? true : false)});
				}
			}
		dialogRows.add().staticTexts.add({staticLabel:"\u00A9 Oleg Butrin"});
		dialogRows.add().staticTexts.add({staticLabel:"http://indesign.rudtp.ru"});
		}
		with (dialogColumns.add()) {
			with (borderPanels.add().dialogColumns.add()) {
				dialogRows.add().staticTexts.add({staticLabel:langSelectParaStyle});
				var myStyle = dialogRows.add().dropdowns.add({stringList:myParaStyleNames, selectedIndex:iniFirstStyle});
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:langSelectSize});
					}
					with (dialogColumns.add()) {
						var mySize = measurementEditboxes.add({minWidth:55, minimumValue:iniMinSize, maximumValue:iniMaxSize, smallNudge:0.1, largeNudge:0.05});
					}
				}
				var myAutoLeading = dialogRows.add().checkboxControls.add({staticLabel:langChangeLeading, checkedState:iniChangeLeading});
				var myFitText = dialogRows.add().checkboxControls.add({staticLabel:langFitText, checkedState:iniFitText});
			}
		}
	}
// 
	var myResult = myDialog.show();
// ,  	
	if (!myResult) {
		myDialog.destroy;
		exit;
	}
//   ,   , 
	if ((myObjects.selectedButton == 0) && (selection.length < 1)) {
		myDialog.destroy;
		exit;		
	}
//    
	if (myFitText.checkedState) {
		switch (myObjects.selectedButton) {
//       
			case 0:
				var myStories = getStoriesFromSelection(selection);
			break;
			case 1:
				var myStories = activeDocument.stories;
			break;
		}
//  
		for (myCounter = 0; myCounter < myStories.length; myCounter++) {
			fitText(myStories[myCounter], myStyle.selectedIndex, myAutoLeading.checkedState);
		}
	} else {
		switch (myObjects.selectedButton) {
			case 0:
				var myObject = getStoriesFromSelection(selection);
			break;
			case 1:
				var myObject = activeDocument;
			break;
		}
		resizeText(myObject, myStyle.selectedIndex, mySize.editValue, myAutoLeading.checkedState);
	}
}